# TOOL FOR MERGING PREPROCESSED CORPS TEXT FILES (e.g. REMOVAL OF TAGS)
# by Seong-Eun Cho
# University of Bergen
# MA Thesis (2013)

use warnings;
use strict;
use utf8;

# Grep File Names in Folder "result_plaintext"
opendir (DIR, "./result_plaintext") or die "$!";

# Get Speeches by Barack Obama ("bobama")
# Change "bobama" if other person's speeches are desired
my @files = grep {/plain_bobama.+/}  readdir DIR;
close DIR;

# List of Speeches
my @text_merged;

# Read-In Speeches
foreach my $file (@files) {
	open(my $corpus,"./result_plaintext/$file") or die "$!";
	my @input = <$corpus>;
	my $inputstring = join("",@input);
	close($corpus);

		push(@text_merged,$inputstring);
}

# Merge Speeches
my $merged = join("\n",@text_merged);	

# Print Output
open(my $out, '>', "merged.txt")
	or die "Couldn't open merged.txt\n";

print $out $merged;
close $out;