#!/usr/bin/perl
use warnings;
use strict;
use utf8;
use Fcntl;
use Storable;

# Load Time Lexicon (Multigram)
print "\nLoading TimeLex\n";
	my %TimeLex6 = %{retrieve('TimeLex6')};
	my %TimeLex5 = %{retrieve('TimeLex5')};
	my %TimeLex4 = %{retrieve('TimeLex4')};
	my %TimeLex3 = %{retrieve('TimeLex3')};
	my %TimeLex2 = %{retrieve('TimeLex2')};

# Load Event Lexicon (Multigram)
print "Loading EventLex\n";
	my %EventLex5 = %{retrieve('EventLex5')};
	my %EventLex4 = %{retrieve('EventLex4')};
	my %EventLex3 = %{retrieve('EventLex3')};
	my %EventLex2 = %{retrieve('EventLex2')};

# Read Input
my $sentences;
sysopen(F, "../(input)", O_RDONLY)
	or die "Can't open input";

# Read-In Memory Space
sysread(F, $sentences, 100_000_000);


# Tag Multigram Time Nouns
print "PARSING - TimeLex: 6\n";
foreach my $key (keys %TimeLex6) {
	my @words = split(/\s/,$key);
	$sentences =~ s/\b($words[0]) ($words[1]) ($words[2]) ($words[3]) ($words[4]) ($words[5])\b/time\($1^$2^$3^$4^$5^$6\)/ig;
}

print "PARSING - TimeLex: 5\n";
foreach my $key (keys %TimeLex5) {
	my @words = split(/\s/,$key);
	$sentences =~ s/\b($words[0]) ($words[1]) ($words[2]) ($words[3]) ($words[4])\b/time\($1^$2^$3^$4^$5\)/ig;
}

print "PARSING - TimeLex: 4\n";
foreach my $key (keys %TimeLex4) {
	my @words = split(/\s/,$key);
	$sentences =~ s/\b($words[0]) ($words[1]) ($words[2]) ($words[3])\b/time\($1^$2^$3^$4\)/ig;
}

print "PARSING - TimeLex: 3\n";
foreach my $key (keys %TimeLex3) {
	my @words = split(/\s/,$key);
	$sentences =~ s/\b($words[0]) ($words[1]) ($words[2])\b/time\($1^$2^$3\)/ig;
}

print "PARSING - TimeLex: 2\n";
foreach my $key (keys %TimeLex2) {
	my @words = split(/\s/,$key);
	$sentences =~ s/\b($words[0]) ($words[1])\b/time\($1^$2\)/ig;
}


# Tag Multigram Event Nouns
print "PARSING - EventLex: 5\n";
foreach my $key (keys %EventLex5) {
	my @words = split(/\s/,$key);
	$sentences =~ s/\b($words[0]) ($words[1]) ($words[2]) ($words[3]) ($words[4])\b/event\($1^$2^$3^$4^$5\)/ig;
}

print "PARSING - EventLex: 4\n";
foreach my $key (keys %EventLex4) {
	my @words = split(/\s/,$key);
	$sentences =~ s/\b($words[0]) ($words[1]) ($words[2]) ($words[3])\b/event\($1^$2^$3^$4\)/ig;
}

print "PARSING - EventLex: 3\n";
foreach my $key (keys %EventLex3) {
	my @words = split(/\s/,$key);
	$sentences =~ s/\b($words[0]) ($words[1]) ($words[2])\b/event\($1^$2^$3\)/ig;
}

print "PARSING - EventLex: 2\n";
foreach my $key (keys %EventLex2) {
	my @words = split(/\s/,$key);
	$sentences =~ s/\b($words[0]) ($words[1])\b/event\($1^$2\)/ig;
}

# Print Output
open (my $out, ">", "../#1.input.multigram")
	or die "Can't save output";

print $out $sentences;
close $out;