#!/usr/bin/perl
use warnings;
use strict;
use utf8;
use IO::Handle;
use Fcntl;
use Storable;

# Load Time/Event Lexicon (Unigram)
my %TimeLex1 = %{retrieve('TimeLex1')};
my %EventLex1 = %{retrieve('EventLex1')};

# Read Input
my $sentences;
sysopen(F, "../#1.input.multigram.pos", O_RDONLY)
	or die "Can't open input";

# Read-In Memory Space
sysread(F, $sentences, 100_000_000);

# Tag Unigram Time Nouns
print "\nRegEx: Time Nouns";
# Time Nouns
#(\s|^^) to (\b) 21.03.2013
foreach my $key (keys %TimeLex1) {
	$sentences =~ s/(\b)($key)\/NN[PS]?([.\s])/$1time\($2\)$3/ig;
}

# Tag Unigram Event Nouns
print "\nRegEx: Event Nouns\n";
# Event Nouns
foreach my $key (keys %EventLex1) {
	$sentences =~ s/(\b)($key)\/NN[PS]?([.\s])/$1event\($2\)$3/ig;
}

# Put Abbreviations Together
$sentences =~ s/\/LS \.\/\./\./g;
# Remove Meta-Tags
$sentences =~ s/\/\S+ / /g;
# Remove ^
$sentences =~ s/\^/ /g;
# time New^Year's^Eve -> time(New^Year's^Eve) 
$sentences =~ s/(time|event)\((time|event)\)\s+\(\s(.*?)\s\)(\s)/$1($3)$4/g;
# Split by Sentences
$sentences =~ s/ \. /\.\n/g;

# Print Output
open (my $out, ">", "../#2.input.unigram")
	or die "Can't save output";

print $out $sentences;
close $out;