# CTM DETECTOR
# by Seong-Eun Cho
# University of Bergen
# MA Thesis (2013)

#!/bin/sh
echo "\n\nConceptual Time Metaphor Detector" ;
echo "\t(Implementation: Master's Thesis // DASP 350)" ;
echo "\tby Seong-Eun CHO" ;
echo "\tUniversity of Bergen, Computational Linguistics" ;
echo "\tSupervisor: Prof. Koenraad De Smedt\n" ;

# TIME/EVENT TAGGER 
echo "---------------------------------------------------" ;
echo "Stage 1: TIME/EVENT TAGGER" ; # (e.g.: New Year's Eve -> New^Years^Eve)
echo "---------------------------------------------------" ;
echo "		Multi-Gram Analysis" ;
echo "		-------------------" ;
cd 1_TimeEventTagger_multiGram ;
perl timeevent_tagger_multi.pl ;
cd .. ;

echo "\n		English CRF Tagger" ;
echo "		------------------" ;
java -mx5000m -classpath 2_CRFTagger/crftagger.jar crf.tagger.CRFTagger -modeldir ./2_CRFTagger/model -inputfile ./\#1.input.multigram -outputfile \#output;

echo "\n		UniGram Analysis" ; # (e.g.: Christmas/NNP -> time(Christmas))
echo "		-----------------" ;
cd 3_TimeEventTagger_uniGram ;
perl timeevent_tagger_uni.pl ;
cd .. ;
echo "\t\t\t..done!\n" ;

# Filter Sentences
echo "---------------------------------------------------" ;
echo "Stage 2: Filter Sentences" ;
echo "---------------------------------------------------" ;
cd 4_TimeEvent_Filter ;
perl filter.pl ;
cd .. ;
echo "\t\t\t..done!\n" ;

# Stanford Parser 
echo "---------------------------------------------------" ;
echo "Stage 3: Stanford Parser" ;
echo "---------------------------------------------------" ;
sh ./5_StanfordParser/lexparser.sh ./\#3.input.filtered > \#4.output.stanfordparser ;
echo "\t\t\t..done!" ;

# Agentive Verb Parser 
echo "\n---------------------------------------------------" ;
echo "Stage 4: Agentive Verb Parser " ;
echo "---------------------------------------------------" ;
cd 6_MotionSightTagger ;
perl motionsight_tagger.pl ;
cd .. ;
echo "\t\t\t..done!" ;

# CMT Extractor
echo "\n---------------------------------------------------" ;
echo "Stage 5: CMT Extractor " ;
echo "---------------------------------------------------" ;
echo "\nRESULTS:" ;
cd 7_CTM-Extraction ;
perl ctm-extractor.pl ;
cd .. ;