# TOOL FOR CREATING A LIST OF INTERNATIONAL PUBLIC HOLIDAYS (http://en.wikipedia.org/wiki/List_of_holidays_by_country - DATE: 22.11.2012)
# by Seong-Eun Cho
# University of Bergen
# MA Thesis (2013)

use warnings;
use strict;
use utf8;
use Storable;

# Load/Save Wiki Public Holidays List
open my $input, '<', "holiday_input.txt"
	or die "Could not open file\n";

my @lexicon = <$input>;
close $input;

# Holidays Lexicon
my %HolidaysLex;
my @Holidays;

foreach (@lexicon) {
	chomp($_);
	$HolidaysLex{$_}++
}

open(my $out, '>', "HolidayList")
	or die "Could not open Output";

foreach (sort keys %HolidaysLex) {
	if ($HolidaysLex{$_} >= 2) {
		print $out $_."\n";
	}
}

close $out;